
stages:
  - test
  - qa

# Select what we should cache between builds
cache:
  paths:
    - vendor/
  key: ${CI_JOB_NAME}
  paths:
    - .sonar/cache

# Bring in any services we need http://docs.gitlab.com/ee/ci/docker/using_docker_images.html#what-is-a-service
# See http://docs.gitlab.com/ce/ci/services/README.html for examples.
services:
  - mysql:5.7

# Set any variables we need
variables:
  # Configure mysql environment variables (https://hub.docker.com/r/_/mysql/)
  MYSQL_DATABASE: mysql_database
  MYSQL_ROOT_PASSWORD: mysql_strong_password
  # Configure sonarqube environment variables (https://docs.sonarqube.org/latest/analysis/gitlab-cicd/)
  SONAR_TOKEN: "e41642460bb57724ce02f8fd5caf1bb2bf0fde18"
  SONAR_HOST_URL: "http://vps821252.ovh.net:9000"
  SONAR_USER_HOME: "${CI_PROJECT_DIR}/.sonar" # Defines the location of the analysis task cache
  GIT_DEPTH: 0 # Tells git to fetch all the branches of the project, required by the analysis task

# Run our tests
# If Xdebug was installed you can generate a coverage report and see code coverage metrics.
test:
  stage:
    test
  script:
    - bin/phpunit --coverage-text --colors=never --log-junit testReports.xml
  image: 
    php:latest
  before_script:
    - apt-get update -yqq
    - apt-get install -yqq git libmcrypt-dev libpq-dev libcurl4-gnutls-dev libicu-dev libvpx-dev libjpeg-dev libpng-dev libxpm-dev zlib1g-dev libfreetype6-dev libxml2-dev libexpat1-dev libbz2-dev libgmp3-dev libldap2-dev unixodbc-dev libsqlite3-dev libaspell-dev libsnmp-dev libpcre3-dev libtidy-dev libzip-dev
    # Install PHP extensions
    - docker-php-ext-install zip xml #mbstring pdo_pgsql curl json intl gd xml zip bz2 opcache
    # Install and run Composer
    - curl -sS https://getcomposer.org/installer | php
    - php composer.phar install
    - chmod 775 bin/phpunit
  artifacts:
    reports:
      junit: testReports.xml

# Run SonarQube scan
sonarqube-check:
  stage: qa
  script:
    - sonar-scanner -Dsonar.qualitygate.wait=true
  image:
    name: sonarsource/sonar-scanner-cli:latest
  allow_failure: true
  only:
    - merge_requests
    - master
